"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.exhaustiveUnion = void 0;
const exhaustive_js_1 = __importDefault(require("./exhaustive.js"));
const invalid_js_1 = __importDefault(require("./invalid.js"));
const maybe_js_1 = __importDefault(require("./maybe.js"));
const exhaustiveUnion = (...as) => (input) => {
    for (const a of as) {
        const [s, r] = (0, maybe_js_1.default)((0, exhaustive_js_1.default)(a))(input);
        if (typeof r !== 'undefined') {
            return [s, r];
        }
    }
    throw new invalid_js_1.default(input);
};
exports.exhaustiveUnion = exhaustiveUnion;
exports.default = exports.exhaustiveUnion;
