"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.union = void 0;
const invalid_js_1 = __importDefault(require("./invalid.js"));
const maybe_js_1 = __importDefault(require("./maybe.js"));
const union = (...as) => input => {
    for (const a of as) {
        const [s, r] = (0, maybe_js_1.default)(a)(input);
        if (typeof r !== 'undefined') {
            return [s, r];
        }
    }
    throw new invalid_js_1.default(input);
};
exports.union = union;
exports.default = exports.union;
