"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.whileChar = void 0;
const util_1 = require("util");
const invalid_js_1 = __importDefault(require("./invalid.js"));
const whileChar = (chars, min = 0) => input => {
    let i;
    for (i = 0; i < input.length; i++) {
        if (!chars.includes(input[i])) {
            break;
        }
    }
    if (i < min) {
        throw new invalid_js_1.default(`Expected ${min} minimum characters passing predicate, character ${(0, util_1.inspect)(input[i])} didn't pass.`);
    }
    return [input.slice(i), input.slice(0, i)];
};
exports.whileChar = whileChar;
exports.default = exports.whileChar;
