import exhaustive from './exhaustive.js';
import Invalid from './invalid.js';
import maybe from './maybe.js';
export const exhaustiveUnion = (...as) => (input) => {
    for (const a of as) {
        const [s, r] = maybe(exhaustive(a))(input);
        if (typeof r !== 'undefined') {
            return [s, r];
        }
    }
    throw new Invalid(input);
};
export default exhaustiveUnion;
